001 /*
002 * Sonar, open source software quality management tool.
003 * Copyright (C) 2008-2011 SonarSource
004 * mailto:contact AT sonarsource DOT com
005 *
006 * Sonar is free software; you can redistribute it and/or
007 * modify it under the terms of the GNU Lesser General Public
008 * License as published by the Free Software Foundation; either
009 * version 3 of the License, or (at your option) any later version.
010 *
011 * Sonar is distributed in the hope that it will be useful,
012 * but WITHOUT ANY WARRANTY; without even the implied warranty of
013 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
014 * Lesser General Public License for more details.
015 *
016 * You should have received a copy of the GNU Lesser General Public
017 * License along with Sonar; if not, write to the Free Software
018 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02
019 */
020 package org.sonar.wsclient.services;
021
022 import java.util.Date;
023
024 /**
025 * @since 2.2
026 */
027 public abstract class AbstractQuery<MODEL extends Model> {
028
029 /**
030 * Must start with a slash, for example: /api/metrics
031 */
032 public abstract String getUrl();
033
034 /**
035 * Request body. By defaut it is empty but it can be overriden.
036 */
037 public String getBody() {
038 return null;
039 }
040
041 protected static void appendUrlParameter(StringBuilder url, String paramKey, Object paramValue) {
042 if (paramValue != null) {
043 url.append(paramKey)
044 .append('=')
045 .append(paramValue)
046 .append('&');
047 }
048 }
049
050 protected static void appendUrlParameter(StringBuilder url, String paramKey, Object[] paramValues) {
051 if (paramValues != null) {
052 url.append(paramKey).append('=');
053 for (int index = 0; index < paramValues.length; index++) {
054 if (index > 0) {
055 url.append(',');
056 }
057 if (paramValues[index] != null) {
058 url.append(paramValues[index]);
059 }
060 }
061 url.append('&');
062 }
063 }
064
065 protected static void appendUrlParameter(StringBuilder url, String paramKey, Date paramValue, boolean includeTime) {
066 if (paramValue != null) {
067 String format = (includeTime ? "yyyy-MM-dd'T'HH:mm:ssZ" : "yyyy-MM-dd");
068 url.append(paramKey)
069 .append('=')
070 .append(WSUtils.getINSTANCE().encodeUrl(WSUtils.getINSTANCE().format(paramValue, format)))
071 .append('&');
072 }
073 }
074 }